package com.faranegar.barcode_reader;


import android.content.Intent;
import android.content.pm.PackageManager;

import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/**
 * BarcodeReaderPlugin
 */
public class BarcodeReaderPlugin implements MethodCallHandler {
    private static AndroidBarcodeScannerFactory androidBarcode;

    /**
     * Plugin registration.
     */
    public static void registerWith(Registrar registrar) {
        if (registrar.activity() != null) {
                registrar
                        .platformViewRegistry()
                        .registerViewFactory(
                                "com.faranegar/androidbarcodescanner"
                                , new AndroidBarcodeScannerFactory(registrar));
        }
    }


    @Override
    public void onMethodCall(MethodCall call, Result result) {
        if (call.method.equals("getPlatformVersion")) {
            result.success("Android " + android.os.Build.VERSION.RELEASE);
        } else {
            result.notImplemented();
        }
    }
}
